
/* GENERATED CODE... DO NOT EDIT */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Copyright (C) 2013 - 2014 Aleksander Morgado <aleksander@aleksander.es>
 */


#include <string.h>

#include "mbim-atds.h"
#include "mbim-message-private.h"
#include "mbim-enum-types.h"
#include "mbim-error-types.h"
#include "mbim-device.h"
#include "mbim-utils.h"

/*****************************************************************************/
/* Struct: MbimAtdsProvider */

static void
_mbim_atds_provider_free (MbimAtdsProvider *var)
{
    if (!var)
        return;

    g_free (var->provider_id);
    g_free (var->provider_name);
    g_free (var);
}

/**
 * mbim_atds_provider_array_free:
 * @array: a #NULL terminated array of #MbimAtdsProvider structs.
 *
 * Frees the memory allocated for the array of #MbimAtdsProviders.
 */
void
mbim_atds_provider_array_free (MbimAtdsProvider **array)
{
    guint32 i;

    if (!array)
        return;

    for (i = 0; array[i]; i++)
        _mbim_atds_provider_free (array[i]);
    g_free (array);
}

static MbimAtdsProvider *
_mbim_message_read_mbim_atds_provider_struct (
    const MbimMessage *self,
    guint32 relative_offset,
    guint32 *bytes_read)
{
    MbimAtdsProvider *out;
    guint32 offset = relative_offset;

    g_assert (self != NULL);

    out = g_new (MbimAtdsProvider, 1);

    out->provider_id = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->provider_state = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->provider_name = _mbim_message_read_string (self, relative_offset, offset);
    offset += 8;

    out->plmn_mode = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->rssi = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    out->error_rate = _mbim_message_read_guint32 (self, offset);
    offset += 4;

    if (bytes_read)
        *bytes_read = (offset - relative_offset);

    return out;
}

static MbimAtdsProvider **
_mbim_message_read_mbim_atds_provider_struct_array (
    const MbimMessage *self,
    guint32 array_size,
    guint32 relative_offset_array_start,
    gboolean refs)
{
    MbimAtdsProvider **out;
    guint32 i;
    guint32 offset;

    if (!array_size)
        return NULL;

    out = g_new (MbimAtdsProvider *, array_size + 1);

    if (!refs) {
        offset = _mbim_message_read_guint32 (self, relative_offset_array_start);
        for (i = 0; i < array_size; i++, offset += 0)
            out[i] = _mbim_message_read_mbim_atds_provider_struct (self, offset, NULL);
    } else {
        offset = relative_offset_array_start;
        for (i = 0; i < array_size; i++, offset += 8)
            out[i] = _mbim_message_read_mbim_atds_provider_struct (self, _mbim_message_read_guint32 (self, offset), NULL);
    }
    out[array_size] = NULL;

    return out;
}

static GByteArray *
_mbim_atds_provider_struct_new (const MbimAtdsProvider *value)
{
    MbimStructBuilder *builder;

    g_assert (value != NULL);

    builder = _mbim_struct_builder_new ();
    _mbim_struct_builder_append_string (builder, value->provider_id);
    _mbim_struct_builder_append_guint32 (builder, value->provider_state);
    _mbim_struct_builder_append_string (builder, value->provider_name);
    _mbim_struct_builder_append_guint32 (builder, value->plmn_mode);
    _mbim_struct_builder_append_guint32 (builder, value->rssi);
    _mbim_struct_builder_append_guint32 (builder, value->error_rate);

    return _mbim_struct_builder_complete (builder);
}

static void
_mbim_struct_builder_append_mbim_atds_provider_struct (
    MbimStructBuilder *builder,
    const MbimAtdsProvider *value)
{
    GByteArray *raw;

    raw = _mbim_atds_provider_struct_new (value);
    g_byte_array_append (builder->fixed_buffer, raw->data, raw->len);
    g_byte_array_unref (raw);
}

static void
_mbim_message_command_builder_append_mbim_atds_provider_struct (
    MbimMessageCommandBuilder *builder,
    const MbimAtdsProvider *value)
{
    _mbim_struct_builder_append_mbim_atds_provider_struct (builder->contents_builder, value);
}

static void
_mbim_struct_builder_append_mbim_atds_provider_struct_array (
    MbimStructBuilder *builder,
    const MbimAtdsProvider *const *values,
    guint32 n_values,
    gboolean refs)
{
    guint32 offset;
    guint32 i;
    GByteArray *raw_all = NULL;

    if (!refs) {
        for (i = 0; i < n_values; i++) {
            GByteArray *raw;

            raw = _mbim_atds_provider_struct_new (values[i]);
            if (!raw_all)
                raw_all = raw;
            else {
                g_byte_array_append (raw_all, raw->data, raw->len);
                g_byte_array_unref (raw);
            }
        }

        if (!raw_all) {
            offset = 0;
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
        } else {
            guint32 offset_offset;

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;
            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);
            /* Add the final array itself */
            g_byte_array_append (builder->variable_buffer, raw_all->data, raw_all->len);
            g_byte_array_unref (raw_all);
        }
    } else {
        for (i = 0; i < n_values; i++) {
            guint32 length;
            guint32 offset_offset;
            GByteArray *raw;

            raw = _mbim_atds_provider_struct_new (values[i]);
            g_assert (raw->len > 0);

            /* Offset of the offset */
            offset_offset = builder->fixed_buffer->len;

            /* Length *not* in LE yet */
            offset = builder->variable_buffer->len;
            /* Add the offset value */
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&offset, sizeof (offset));
            /* Configure the value to get updated */
            g_array_append_val (builder->offsets, offset_offset);

            /* Add the length value */
            length = GUINT32_TO_LE (raw->len);
            g_byte_array_append (builder->fixed_buffer, (guint8 *)&length, sizeof (length));

            /* And finally, the bytearray itself to the variable buffer */
            g_byte_array_append (builder->variable_buffer, (const guint8 *)raw->data, (guint)raw->len);
            g_byte_array_unref (raw);
        }
    }
}

static void
_mbim_message_command_builder_append_mbim_atds_provider_struct_array (
    MbimMessageCommandBuilder *builder,
    const MbimAtdsProvider *const *values,
    guint32 n_values,
    gboolean refs)
{
    _mbim_struct_builder_append_mbim_atds_provider_struct_array (builder->contents_builder, values, n_values, refs);
}

/*****************************************************************************/
/* Message (Query): MBIM Message ATDS Signal */

/**
 * mbim_message_atds_signal_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Signal' query command in the 'ATDS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_atds_signal_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_ATDS,
                                                 MBIM_CID_ATDS_SIGNAL,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message ATDS Signal */

/**
 * mbim_message_atds_signal_response_parse:
 * @message: the #MbimMessage.
 * @rssi: return location for a #guint32, or %NULL if the 'Rssi' field is not needed.
 * @error_rate: return location for a #guint32, or %NULL if the 'ErrorRate' field is not needed.
 * @rscp: return location for a #guint32, or %NULL if the 'Rscp' field is not needed.
 * @ecno: return location for a #guint32, or %NULL if the 'Ecno' field is not needed.
 * @rsrq: return location for a #guint32, or %NULL if the 'Rsrq' field is not needed.
 * @rsrp: return location for a #guint32, or %NULL if the 'Rsrp' field is not needed.
 * @rssnr: return location for a #guint32, or %NULL if the 'Rssnr' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Signal' response command in the 'ATDS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_atds_signal_response_parse (
    const MbimMessage *message,
    guint32 *rssi,
    guint32 *error_rate,
    guint32 *rscp,
    guint32 *ecno,
    guint32 *rsrq,
    guint32 *rsrp,
    guint32 *rssnr,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Rssi' variable */
    {
        if (rssi != NULL)
            *rssi =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ErrorRate' variable */
    {
        if (error_rate != NULL)
            *error_rate =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Rscp' variable */
    {
        if (rscp != NULL)
            *rscp =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Ecno' variable */
    {
        if (ecno != NULL)
            *ecno =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Rsrq' variable */
    {
        if (rsrq != NULL)
            *rsrq =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Rsrp' variable */
    {
        if (rsrp != NULL)
            *rsrp =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Rssnr' variable */
    {
        if (rssnr != NULL)
            *rssnr =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Query): MBIM Message ATDS Location */

/**
 * mbim_message_atds_location_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Location' query command in the 'ATDS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_atds_location_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_ATDS,
                                                 MBIM_CID_ATDS_LOCATION,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message ATDS Location */

/**
 * mbim_message_atds_location_response_parse:
 * @message: the #MbimMessage.
 * @lac: return location for a #guint32, or %NULL if the 'Lac' field is not needed.
 * @tac: return location for a #guint32, or %NULL if the 'Tac' field is not needed.
 * @cell_id: return location for a #guint32, or %NULL if the 'CellId' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Location' response command in the 'ATDS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_atds_location_response_parse (
    const MbimMessage *message,
    guint32 *lac,
    guint32 *tac,
    guint32 *cell_id,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Lac' variable */
    {
        if (lac != NULL)
            *lac =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'Tac' variable */
    {
        if (tac != NULL)
            *tac =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CellId' variable */
    {
        if (cell_id != NULL)
            *cell_id =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Query): MBIM Message ATDS Operators */

/**
 * mbim_message_atds_operators_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Operators' query command in the 'ATDS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_atds_operators_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_ATDS,
                                                 MBIM_CID_ATDS_OPERATORS,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message ATDS Operators */

/**
 * mbim_message_atds_operators_response_parse:
 * @message: the #MbimMessage.
 * @providers_count: return location for a #guint32, or %NULL if the 'ProvidersCount' field is not needed.
 * @providers: return location for a newly allocated array of #MbimAtdsProviders, or %NULL if the 'Providers' field is not needed. Free the returned value with mbim_atds_provider_array_free().
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Operators' response command in the 'ATDS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_atds_operators_response_parse (
    const MbimMessage *message,
    guint32 *providers_count,
    MbimAtdsProvider ***providers,
    GError **error)
{
    guint32 offset = 0;
    guint32 _providers_count;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'ProvidersCount' variable */
    {
        _providers_count = _mbim_message_read_guint32 (message, offset);
        if (providers_count != NULL)
            *providers_count = _providers_count;
        offset += 4;
    }

    /* Read the 'Providers' variable */
    {
        if (providers != NULL)
            *providers = _mbim_message_read_mbim_atds_provider_struct_array (message, _providers_count, offset, TRUE);
        offset += (8 * _providers_count);
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Query): MBIM Message ATDS RAT */

/**
 * mbim_message_atds_rat_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'RAT' query command in the 'ATDS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_atds_rat_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_ATDS,
                                                 MBIM_CID_ATDS_RAT,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Set): MBIM Message ATDS RAT */

/**
 * mbim_message_atds_rat_set_new:
 * @mode: the 'Mode' field, given as a #MbimAtdsRatMode.
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'RAT' set command in the 'ATDS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_atds_rat_set_new (
    MbimAtdsRatMode mode,
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_ATDS,
                                                 MBIM_CID_ATDS_RAT,
                                                 MBIM_MESSAGE_COMMAND_TYPE_SET);
    {
        _mbim_message_command_builder_append_guint32 (builder, mode);
    }

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message ATDS RAT */

/**
 * mbim_message_atds_rat_response_parse:
 * @message: the #MbimMessage.
 * @mode: return location for a #MbimAtdsRatMode, or %NULL if the 'Mode' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'RAT' response command in the 'ATDS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_atds_rat_response_parse (
    const MbimMessage *message,
    MbimAtdsRatMode *mode,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'Mode' variable */
    {
        if (mode != NULL)
            *mode =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}

/*****************************************************************************/
/* Message (Query): MBIM Message ATDS Register State */

/**
 * mbim_message_atds_register_state_query_new:
 * @error: return location for error or %NULL.
 *
 * Create a new request for the 'Register State' query command in the 'ATDS' service.
 *
 * Returns: a newly allocated #MbimMessage, which should be freed with mbim_message_unref().
 */
MbimMessage *
mbim_message_atds_register_state_query_new (
    GError **error)
{
    MbimMessageCommandBuilder *builder;

    builder = _mbim_message_command_builder_new (0,
                                                 MBIM_SERVICE_ATDS,
                                                 MBIM_CID_ATDS_REGISTER_STATE,
                                                 MBIM_MESSAGE_COMMAND_TYPE_QUERY);

    return _mbim_message_command_builder_complete (builder);
}

/*****************************************************************************/
/* Message (Response): MBIM Message ATDS Register State */

/**
 * mbim_message_atds_register_state_response_parse:
 * @message: the #MbimMessage.
 * @nw_error: return location for a #MbimNwError, or %NULL if the 'NwError' field is not needed.
 * @register_state: return location for a #MbimRegisterState, or %NULL if the 'RegisterState' field is not needed.
 * @register_mode: return location for a #MbimRegisterMode, or %NULL if the 'RegisterMode' field is not needed.
 * @available_data_classes: return location for a #MbimDataClass, or %NULL if the 'AvailableDataClasses' field is not needed.
 * @current_cellular_class: return location for a #MbimCellularClass, or %NULL if the 'CurrentCellularClass' field is not needed.
 * @provider_id: return location for a newly allocated string, or %NULL if the 'ProviderId' field is not needed. Free the returned value with g_free().
 * @provider_name: return location for a newly allocated string, or %NULL if the 'ProviderName' field is not needed. Free the returned value with g_free().
 * @roaming_text: return location for a newly allocated string, or %NULL if the 'RoamingText' field is not needed. Free the returned value with g_free().
 * @registration_flag: return location for a #MbimRegistrationFlag, or %NULL if the 'RegistrationFlag' field is not needed.
 * @error: return location for error or %NULL.
 *
 * Parses and returns parameters of the 'Register State' response command in the 'ATDS' service.
 *
 * Returns: %TRUE if the message was correctly parsed, %FALSE if @error is set.
 */
gboolean
mbim_message_atds_register_state_response_parse (
    const MbimMessage *message,
    MbimNwError *nw_error,
    MbimRegisterState *register_state,
    MbimRegisterMode *register_mode,
    MbimDataClass *available_data_classes,
    MbimCellularClass *current_cellular_class,
    gchar **provider_id,
    gchar **provider_name,
    gchar **roaming_text,
    MbimRegistrationFlag *registration_flag,
    GError **error)
{
    guint32 offset = 0;

    if (mbim_message_get_message_type (message) != MBIM_MESSAGE_TYPE_COMMAND_DONE) {
        g_set_error (error,
                     MBIM_CORE_ERROR,
                     MBIM_CORE_ERROR_INVALID_MESSAGE,
                     "Message is not a response");
        return FALSE;
    }

    /* Read the 'NwError' variable */
    {
        if (nw_error != NULL)
            *nw_error =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RegisterState' variable */
    {
        if (register_state != NULL)
            *register_state =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'RegisterMode' variable */
    {
        if (register_mode != NULL)
            *register_mode =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'AvailableDataClasses' variable */
    {
        if (available_data_classes != NULL)
            *available_data_classes =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'CurrentCellularClass' variable */
    {
        if (current_cellular_class != NULL)
            *current_cellular_class =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    /* Read the 'ProviderId' variable */
    {
        if (provider_id != NULL)
            *provider_id = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'ProviderName' variable */
    {
        if (provider_name != NULL)
            *provider_name = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'RoamingText' variable */
    {
        if (roaming_text != NULL)
            *roaming_text = _mbim_message_read_string (message, 0, offset);
        offset += 8;
    }

    /* Read the 'RegistrationFlag' variable */
    {
        if (registration_flag != NULL)
            *registration_flag =  _mbim_message_read_guint32 (message, offset);
        offset += 4;
    }

    return TRUE;
}
